#include <boost/spirit/home/qi.hpp>

namespace ecgp {

    namespace qi = boost::spirit::qi;
    namespace ascii = boost::spirit::ascii;

    template <typename Iterator>
    struct ident: qi::grammar<Iterator, std::string(), ascii::space_type> {

      ident(): ident::base_type(start) {
        using namespace qi;
        start %= lexeme[('_' | alpha) >> *(digit | alpha | '_' | '-')]; 
      }
      qi::rule<Iterator, std::string(), ascii::space_type> start;
    };

    template <typename Iterator>
    struct idlist: qi::grammar<Iterator, std::string(), ascii::space_type> {

      ecgp::ident<Iterator> id;
      idlist(): idlist::base_type(start) {
        using namespace qi;
        start %= id >> (char_(',') >> id);     // line A
        //start %= id >> *(char_(',') >> id);  // line B
      }

      qi::rule<Iterator, std::string(), ascii::space_type> start;
    };
}
